"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
function createProvider(init, Provider, initialState) {
    return class RLProvider extends react_1.default.Component {
        constructor(props) {
            super(props);
            this.mounted = true;
            this.state = initialState;
            const setState = (state, callback) => {
                if (!this.mounted) {
                    return;
                }
                this.setState(state, callback);
            };
            init(() => this.state, setState);
        }
        componentWillUnmount() {
            this.mounted = false;
        }
        render() {
            const { children } = this.props;
            return (react_1.default.createElement(Provider, { value: this.state }, typeof children === 'function'
                ? children(this.state)
                : children));
        }
    };
}
exports.createProvider = createProvider;
